mf = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "CandyBar-2.0","AceDB-2.0" )
mf:RegisterDB("mfDB","mfDBPC");
mf:RegisterDefaults("profile", {
x=700,
y=-350
} )

local sstexture=" ";
local xres, yres = 0,0;
local options = {};

function mf:OnEnable()
	self:RegisterEvent("UNIT_AURA","BuffChange");
	self:RegisterEvent("PLAYER_AURAS_CHANGED","BuffChange");
	self:RegisterEvent("UNIT_INVENTORY_CHANGED","BuffChange");
	self:RegisterEvent("PLAYER_LEVEL_UP","BuffChange");
	self:RegisterEvent("CHARACTER_POINTS_CHANGED","BuffChange");
	mf:MeleeFrameSET();
	mf:BuffChange();
	mf:getscreenres();
	mf:setoptions();
	mf:RegisterChatCommand("/mf", "/MF", options);
end

function mf:MeleeFrameSET()
	if (not mf.f) then
		mf.f = CreateFrame("MessageFrame","MeleeFrame",UIParent)
		mf.f:SetFrameStrata("BACKGROUND")
		mf.f:SetWidth(220); 
		mf.f:SetHeight(62);
		mf.f:SetInsertMode("TOP");
--	local t = f:CreateTexture(nil,"BACKGROUND")
--	t:SetTexture("Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Factions.blp")
--	t:SetAllPoints(f)
--	f.texture = t
		mf.f:SetPoint("TOPLEFT", "UIParent", "TOPLEFT",mf.db.profile.x,mf.db.profile.y)
		mf.f:SetTimeVisible(9999999999);
		mf.f:SetFontObject(GameFontNormal);
	end
	mf.f:Show();
end

function mf:BuffChange()
	if ((not arg1) or (arg1=="player")) then
		mf:showMelee();
	end
end

function mf:showMelee()
	local base, posBuff, negBuff = UnitAttackPower("player");
	local effective = base + posBuff + negBuff;
	local critChance = GetCritChance();
	local mainSpeed, offSpeed = UnitAttackSpeed("player");
	local lowDmg, hiDmg, offlowDmg, offhiDmg, posBuff, negBuff, percentmod = UnitDamage("player");
	local haste = GetCombatRatingBonus(18);
	local armorPenetration = GetArmorPenetration();
	if ((mainSpeed) and (offSpeed)) then
		MeleeFrame:AddMessage(string.format("%.2f",offSpeed).." "..ceil(offlowDmg).."-"..ceil(offhiDmg),1,1,1);
		else
		MeleeFrame:AddMessage(" ",1,1,1);
		end
	MeleeFrame:AddMessage(string.format("%.2f",mainSpeed).." "..ceil(lowDmg).."-"..ceil(hiDmg),1,1,1);
	MeleeFrame:AddMessage("-"..armorPenetration.." armor "..string.format("%.2f",haste).."% ht",1,1,1);
	MeleeFrame:AddMessage(effective.."AP "..string.format("%.2f",critChance).."% cr",1,1,1);
end

function mf:getscreenres()
	local xyres=GetCVar("gxResolution");
	xres, yres=strsplit("x",xyres);
	xres=tonumber(xres);
	yres=tonumber(yres);
	-- DEFAULT_CHAT_FRAME:AddMessage(xres.." "..yres);
end

function mf:setoptions()
	options = { 
	    type='group',
	    args = {
	        x = {
	            type = 'range',
	            name = 'Meleex',
	            desc = 'Change X coord of Melee Frame',
	            min = 0,
				max = xres,
				step = 1,
				get = function()
			        return mf.db.profile.x
			    end,
	            set = function(v)
			        mf.db.profile.x=v;
					mf.f:SetPoint("TOPLEFT", "UIParent", "TOPLEFT",mf.db.profile.x,mf.db.profile.y);
			    end
	        },
			y = {
	            type = 'range',
	            name = 'Meleey',
	            desc = 'Change Y coord of Melee Frame',
	            min = (-1)*yres,
				max = 0,
				step = 1,
				get = function()
			        return mf.db.profile.y
			    end,
	            set = function(v)
			        mf.db.profile.y=v;
					mf.f:SetPoint("TOPLEFT", "UIParent", "TOPLEFT",mf.db.profile.x,mf.db.profile.y);
			    end
	        }
	    }
	}
end